# OpenAPI Petstore
#
# This is a sample server Petstore server. For this sample, you can use the api key `special-key` to test the authorization filters.
#
# OpenAPI spec version: 1.0.0
# 
# Generated by: https://openapi-generator.tech


#' Pet Class
#'
#' @field id 
#' @field category 
#' @field name 
#' @field photoUrls 
#' @field tags 
#' @field status 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
Pet <- R6::R6Class(
  'Pet',
  public = list(
    `id` = NULL,
    `category` = NULL,
    `name` = NULL,
    `photoUrls` = NULL,
    `tags` = NULL,
    `status` = NULL,
    initialize = function(`name`, `photoUrls`, `id`=NULL, `category`=NULL, `tags`=NULL, `status`=NULL, ...){
      local.optional.var <- list(...)
      if (!missing(`name`)) {
        stopifnot(is.character(`name`), length(`name`) == 1)
        self$`name` <- `name`
      }
      if (!missing(`photoUrls`)) {
        stopifnot(is.vector(`photoUrls`), length(`photoUrls`) != 0)
        sapply(`photoUrls`, function(x) stopifnot(is.character(x)))
        self$`photoUrls` <- `photoUrls`
      }
      if (!is.null(`id`)) {
        stopifnot(is.numeric(`id`), length(`id`) == 1)
        self$`id` <- `id`
      }
      if (!is.null(`category`)) {
        stopifnot(R6::is.R6(`category`))
        self$`category` <- `category`
      }
      if (!is.null(`tags`)) {
        stopifnot(is.vector(`tags`), length(`tags`) != 0)
        sapply(`tags`, function(x) stopifnot(R6::is.R6(x)))
        self$`tags` <- `tags`
      }
      if (!is.null(`status`)) {
        stopifnot(is.character(`status`), length(`status`) == 1)
        self$`status` <- `status`
      }
    },
    toJSON = function() {
      PetObject <- list()
      if (!is.null(self$`id`)) {
        PetObject[['id']] <-
          self$`id`
      }
      if (!is.null(self$`category`)) {
        PetObject[['category']] <-
          self$`category`$toJSON()
      }
      if (!is.null(self$`name`)) {
        PetObject[['name']] <-
          self$`name`
      }
      if (!is.null(self$`photoUrls`)) {
        PetObject[['photoUrls']] <-
          self$`photoUrls`
      }
      if (!is.null(self$`tags`)) {
        PetObject[['tags']] <-
          sapply(self$`tags`, function(x) x$toJSON())
      }
      if (!is.null(self$`status`)) {
        PetObject[['status']] <-
          self$`status`
      }

      PetObject
    },
    fromJSON = function(PetJson) {
      PetObject <- jsonlite::fromJSON(PetJson)
      if (!is.null(PetObject$`id`)) {
        self$`id` <- PetObject$`id`
      }
      if (!is.null(PetObject$`category`)) {
        categoryObject <- Category$new()
        categoryObject$fromJSON(jsonlite::toJSON(PetObject$category, auto_unbox = TRUE))
        self$`category` <- categoryObject
      }
      if (!is.null(PetObject$`name`)) {
        self$`name` <- PetObject$`name`
      }
      if (!is.null(PetObject$`photoUrls`)) {
        self$`photoUrls` <- PetObject$`photoUrls`
      }
      if (!is.null(PetObject$`tags`)) {
        self$`tags` <- sapply(PetObject$`tags`, function(x) {
          tagsObject <- Tag$new()
          tagsObject$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE))
          tagsObject
        })
      }
      if (!is.null(PetObject$`status`)) {
        self$`status` <- PetObject$`status`
      }
    },
    toJSONString = function() {
      sprintf(
        '{
           "id":
             %d,
           "category":
             %s,
           "name":
             "%s",
           "photoUrls":
             [%s],
           "tags":
             [%s],
           "status":
             "%s"
        }',
        self$`id`,
        jsonlite::toJSON(self$`category`$toJSON(), auto_unbox=TRUE),
        self$`name`,
        paste(unlist(lapply(self$`photoUrls`, function(x) paste0('"', x, '"'))), collapse=","),
        paste(unlist(lapply(self$`tags`, function(x) jsonlite::toJSON(x$toJSON(), auto_unbox=TRUE))), collapse=","),
        self$`status`
      )
    },
    fromJSONString = function(PetJson) {
      PetObject <- jsonlite::fromJSON(PetJson)
      self$`id` <- PetObject$`id`
      self$`category` <- Category$new()$fromJSON(jsonlite::toJSON(PetObject$category, auto_unbox = TRUE))
      self$`name` <- PetObject$`name`
      self$`photoUrls` <- lapply(PetObject$`photoUrls`, function (x) x)
      data.frame <- PetObject$`tags`
      self$`tags` <- vector("list", length = nrow(data.frame))
      for (row in 1:nrow(data.frame)) {
          tags.node <- Tag$new()
          tags.node$fromJSON(jsonlite::toJSON(data.frame[row,,drop = TRUE], auto_unbox = TRUE))
          self$`tags`[[row]] <- tags.node
      }
      self$`status` <- PetObject$`status`
      self
    }
  )
)
